diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 4432309dd..3cec32889 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -17,10 +17,13 @@ import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.client.entity.ClientSkinVariantList;
 import net.minecraft.client.entity.player.PlayerLocal;
+import net.minecraft.client.enums.EnumGPUVendor;
 import net.minecraft.client.gui.*;
 import net.minecraft.client.gui.achievements.ScreenAchievements;
 import net.minecraft.client.gui.chat.ScreenChat;
 import net.minecraft.client.gui.chat.ScreenSleepMP;
+import net.minecraft.client.gui.options.data.OptionsPage;
+import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.net.handler.PacketHandlerClient;
@@ -193,6 +196,7 @@ public class Minecraft
     public static final String VERSION = Global.VERSION;
     public static final boolean isMultiplayerDisabled = false;
     public static boolean doPartialTick = true;
+    public static EnumGPUVendor GPU_VENDOR = EnumGPUVendor.UNKNOWN;
     private static Minecraft INSTANCE;
     public PlayerController playerController;
     public boolean hasCrashed;
@@ -468,6 +472,15 @@ public class Minecraft
 		
 		gameWindow.init(this, overrideWidth != null ? overrideWidth : gameSettings.windowWidth.value, overrideHeight != null ? overrideHeight : gameSettings.windowHeight.value);
 
+        final @Nullable String vendorString = GL11.glGetString(GL_VENDOR);
+        if (vendorString != null) {
+            GPU_VENDOR = EnumGPUVendor.getVendorFromString(vendorString);
+            if (GPU_VENDOR == EnumGPUVendor.INTEL) {
+                // Intel cannot handle the sheer complexity of drawing the lightmap texture upon a quad
+                gameSettings.lightmapStyle.set(LightmapStyle.DISABLED);
+            }
+        }
+
         LOGGER.info("Resolution: {} x {}", gameWindow.getWidthPixels(), gameWindow.getHeightPixels());
 
         resolution.setScale(gameSettings.guiScale.value);
@@ -558,6 +571,8 @@ public class Minecraft
         
         textureManager.refreshTextures(new ArrayList<>());
 
+        OptionsPages.init();
+
         loadScreen();	// Update loading screen so it doesn't say no response
 
         LOGGER.info("Initializing Renderer...");
diff --git a/game/client/src/main/java/net/minecraft/client/enums/EnumGPUVendor.java b/game/client/src/main/java/net/minecraft/client/enums/EnumGPUVendor.java
new file mode 100644
index 000000000..028dc35be
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/enums/EnumGPUVendor.java
@@ -0,0 +1,20 @@
+package net.minecraft.client.enums;
+
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Locale;
+
+public enum EnumGPUVendor {
+    NVIDIA,
+    AMD,
+    INTEL,
+    UNKNOWN;
+
+    public static @NotNull EnumGPUVendor getVendorFromString(final @NotNull String vendorString) {
+        final @NotNull String vendorStringLower = vendorString.toLowerCase(Locale.ROOT);
+        if (vendorStringLower.contains("nvidia corporation")) return NVIDIA;
+        if (vendorStringLower.contains("ati technologies")) return AMD;
+        if (vendorStringLower.contains("intel")) return INTEL;
+        return UNKNOWN;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index 19e56e934..e9d02a99d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -28,7 +28,7 @@ import org.lwjgl.opengl.GL11;
 import org.lwjgl.util.glu.GLU;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.options.OptionsScreen;
+import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.core.block.Block;
@@ -194,7 +194,7 @@ public class ScreenMainMenu extends Screen
     {
         if(button.id == 0)
         {
-            mc.displayScreen(new OptionsScreen(this));
+            mc.displayScreen(new ScreenOptions(this));
         }
         if(button.id == 1)
         {
@@ -206,7 +206,7 @@ public class ScreenMainMenu extends Screen
         }
         if(button.id == 3)
         {
-            mc.displayScreen(new OptionsScreen(this, OptionsPages.TEXTURE_PACKS));
+            mc.displayScreen(new ScreenOptions(this, OptionsPages.TEXTURE_PACKS));
         }
         if(button.id == 4)
         {
@@ -218,10 +218,10 @@ public class ScreenMainMenu extends Screen
         }
         if(button.id == 9)
         {
-            mc.displayScreen(new OptionsScreen(this, OptionsPages.LANGUAGE));
+            mc.displayScreen(new ScreenOptions(this, OptionsPages.LANGUAGE));
         }
         if(button.id == 10){
-            mc.displayScreen(new OptionsScreen(this, OptionsPages.DEBUG));
+            mc.displayScreen(new ScreenOptions(this, OptionsPages.DEBUG));
         }
         Desktop desktop = Desktop.isDesktopSupported() ? Desktop.getDesktop() : null;
         if (desktop != null && desktop.isSupported(Desktop.Action.BROWSE))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java
index ea24a774d..5a0016ec0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java
@@ -4,7 +4,7 @@ import net.minecraft.client.gui.achievements.ScreenAchievements;
 import net.minecraft.client.gui.guidebook.GuidebookPageManager;
 import net.minecraft.client.gui.guidebook.ScreenGuidebook;
 import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
-import net.minecraft.client.gui.options.OptionsScreen;
+import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
@@ -55,7 +55,7 @@ public class ScreenPause extends Screen
     {
         if(button.id == 0)
         {
-            mc.displayScreen(new OptionsScreen(this));
+            mc.displayScreen(new ScreenOptions(this));
         }
         if(button.id == 1)
         {
@@ -93,7 +93,7 @@ public class ScreenPause extends Screen
             mc.displayScreen(new ScreenPhotoMode());
         }
         if(button.id == 9){
-            mc.displayScreen(new OptionsScreen(this, OptionsPages.DEBUG));
+            mc.displayScreen(new ScreenOptions(this, OptionsPages.DEBUG));
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
index 42e815470..db5c2933f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
+import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.core.Global;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Utils;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
@@ -335,6 +337,21 @@ public class ScreenPhotoMode extends Screen
         GL11.glLoadIdentity();
         GL11.glTranslatef(0.0F, 0.0F, -2000F);
 
+        if (mc.controllerInput != null) {
+            if (mc.controllerInput.buttonLeftShoulder.isPressed()) {
+                float div = (float)Math.pow(2, iZoom) / 3;
+                iPanXGoal -= mc.controllerInput.joyRight.getX() / div;
+                iPanYGoal -= mc.controllerInput.joyRight.getY() / div;
+            } else if (mc.controllerInput.buttonLeftTrigger.isPressed()) {
+                iTiltGoal -= mc.controllerInput.joyRight.getY() / 2f;
+                iTiltGoal = MathHelper.clamp(iTiltGoal, 0.0f, 90.0f);
+                updateButtonsText();
+            } else {
+                iRotationGoal -= mc.controllerInput.joyRight.getX() / 64f;
+                iZoomGoal -= mc.controllerInput.joyRight.getY() / 128f;
+            }
+        }
+
         long currentTime = System.currentTimeMillis();
         if (currentTime > lastUpdateTime + 5)
         {
@@ -492,4 +509,9 @@ public class ScreenPhotoMode extends Screen
             iZoomGoal += 0.25f;
         }
     }
+
+    @Override
+    public void guiSpecificControllerInput(ControllerInput controller) {
+
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java b/game/client/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java
index 744dce911..46e4c9b7f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java
@@ -101,26 +101,31 @@ public abstract class ScrolledSelectionList {
     public void render(int x, int y, float partialTicks) {
         renderHoleBackground();
         int numItems = getItemCount();
-        int l = width / 2 + 124;
-        int i1 = l + 6;
+        int scrollbarLeft = width / 2 + 124;
+        int scrollbarRight = scrollbarLeft + 6;
+        if (minecraft.controllerInput != null) {
+            if (Math.abs(minecraft.controllerInput.joyRight.getY()) > 0.1f) {
+                amountScrolled += minecraft.controllerInput.joyRight.getY();
+            }
+        }
         if (Mouse.isButtonDown(0) || (minecraft.controllerInput != null && minecraft.controllerInput.buttonA.isPressed())) {
             if (yDrag == -1F) {
                 boolean flag = true;
                 if (y >= y0 && y <= y1) {
-                    int j1 = width / 2 - 110;
-                    int k1 = width / 2 + 110;
+                    int left = width / 2 - 110;
+                    int right = width / 2 + 110;
                     int i2 = ((y - y0 - headerHeight) + (int) amountScrolled) - 4;
                     int k2 = i2 / itemHeight;
-                    if (x >= j1 && x <= k1 && k2 >= 0 && i2 >= 0 && k2 < numItems) {
+                    if (x >= left && x <= right && k2 >= 0 && i2 >= 0 && k2 < numItems) {
                         boolean flag1 = k2 == selectedElement && System.currentTimeMillis() - lastClicked < 250L;
                         selectItem(k2, flag1);
                         selectedElement = k2;
                         lastClicked = System.currentTimeMillis();
-                    } else if (x >= j1 && x <= k1 && i2 < 0) {
-                        clickedHeader(x - j1, ((y - y0) + (int) amountScrolled) - 4);
+                    } else if (x >= left && x <= right && i2 < 0) {
+                        clickedHeader(x - left, ((y - y0) + (int) amountScrolled) - 4);
                         flag = false;
                     }
-                    if (x >= l && x <= i1) {
+                    if (x >= scrollbarLeft && x <= scrollbarRight) {
                         scrollMultiplier = -1F;
                         int i3 = getMaxPosition() - (y1 - y0 - 4);
                         if (i3 < 1) {
@@ -239,24 +244,24 @@ public abstract class ScrolledSelectionList {
             }
             tessellator.startDrawingQuads();
             tessellator.setColorRGBA_I(0, 255);
-            tessellator.addVertexWithUV(l, y1, 0.0D, 0.0D, 1.0D);
-            tessellator.addVertexWithUV(i1, y1, 0.0D, 1.0D, 1.0D);
-            tessellator.addVertexWithUV(i1, y0, 0.0D, 1.0D, 0.0D);
-            tessellator.addVertexWithUV(l, y0, 0.0D, 0.0D, 0.0D);
+            tessellator.addVertexWithUV(scrollbarLeft, y1, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight, y1, 0.0D, 1.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight, y0, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(scrollbarLeft, y0, 0.0D, 0.0D, 0.0D);
             tessellator.draw();
             tessellator.startDrawingQuads();
             tessellator.setColorRGBA_I(0x808080, 255);
-            tessellator.addVertexWithUV(l, l4 + j4, 0.0D, 0.0D, 1.0D);
-            tessellator.addVertexWithUV(i1, l4 + j4, 0.0D, 1.0D, 1.0D);
-            tessellator.addVertexWithUV(i1, l4, 0.0D, 1.0D, 0.0D);
-            tessellator.addVertexWithUV(l, l4, 0.0D, 0.0D, 0.0D);
+            tessellator.addVertexWithUV(scrollbarLeft, l4 + j4, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight, l4 + j4, 0.0D, 1.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight, l4, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(scrollbarLeft, l4, 0.0D, 0.0D, 0.0D);
             tessellator.draw();
             tessellator.startDrawingQuads();
             tessellator.setColorRGBA_I(0xc0c0c0, 255);
-            tessellator.addVertexWithUV(l, (l4 + j4) - 1, 0.0D, 0.0D, 1.0D);
-            tessellator.addVertexWithUV(i1 - 1, (l4 + j4) - 1, 0.0D, 1.0D, 1.0D);
-            tessellator.addVertexWithUV(i1 - 1, l4, 0.0D, 1.0D, 0.0D);
-            tessellator.addVertexWithUV(l, l4, 0.0D, 0.0D, 0.0D);
+            tessellator.addVertexWithUV(scrollbarLeft, (l4 + j4) - 1, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight - 1, (l4 + j4) - 1, 0.0D, 1.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight - 1, l4, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(scrollbarLeft, l4, 0.0D, 0.0D, 0.0D);
             tessellator.draw();
         }
         renderDecorations(x, y);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index af531b6de..95fd2d77b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -250,8 +250,22 @@ public class ScreenAchievements extends Screen
             }
             currentShiftX =  MathHelper.clamp(currentShiftX, shiftMinX, shiftMaxX);
             currentShiftY =  MathHelper.clamp(currentShiftY, shiftMinY, shiftMaxY);
-        } else
-        {
+        } else if (mc.controllerInput != null) {
+            targetShiftX += mc.controllerInput.joyRight.getX() / viewportZoom * 4;
+            targetShiftY += mc.controllerInput.joyRight.getY() / viewportZoom * 4;
+            currentShiftX = oldShiftX = targetShiftX;
+            currentShiftY = oldShiftY = targetShiftY;
+            currentShiftX =  MathHelper.clamp(currentShiftX, shiftMinX, shiftMaxX);
+            currentShiftY =  MathHelper.clamp(currentShiftY, shiftMinY, shiftMaxY);
+
+            if (mc.controllerInput.buttonLeftTrigger.isPressed()) {
+                viewportZoom -= 0.01d;
+            } else if (mc.controllerInput.buttonRightTrigger.isPressed()) {
+                viewportZoom += 0.01f;
+            }
+            viewportZoom = MathHelper.clamp(viewportZoom, 0.5d, 2d);
+
+        } else {
             clickX = clickY = null;
             oldPagesListScrollAmount = null;
             draggingViewport = false;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
index dabe6af17..bb352248b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
@@ -347,7 +347,11 @@ public class ScreenGuidebook
                 updateTabList();
             }
         }
+        if (controller.buttonB.pressedThisFrame()) {
+            mc.displayScreen(getParentScreen());
+        }
     }
+
     private Tab getTab(GuidebookSection section, boolean searchForward){
         Tab tab = null;
         int index = -1;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index b65691767..451f452ba 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -147,7 +147,7 @@ public class HudIngame extends Gui
         //Text Overlays
         if (mc.gameSettings.immersiveMode.drawOverlays())
         {
-            drawRecordPlayingOverlay(width, height, partialTicks);
+            drawRecordPlayingOverlay(width, height - sp, partialTicks);
 
             int tsp = 2 + sp;
             int line = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 352fa0f17..534729149 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -13,7 +13,7 @@ import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
 import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
-import net.minecraft.client.gui.options.OptionsScreen;
+import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.shader.PhotoModeRenderer;
@@ -401,7 +401,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
     private void exitToMenu(){
         currentCategory.onClose();
         mc.changeWorld(null);
-        mc.displayScreen(new OptionsScreen(null, OptionsPages.DEBUG));
+        mc.displayScreen(new ScreenOptions(null, OptionsPages.DEBUG));
     }
     public static int cycleBlockId(int id, int idOff){
         int id2 = (id + Blocks.blocksList.length + idOff) % Blocks.blocksList.length;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
similarity index 94%
rename from game/client/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
rename to game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index 9b1e88ed6..65c9f64b6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -9,6 +9,7 @@ import net.minecraft.client.gui.options.data.OptionsPage;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.gui.options.data.OptionsPageRegistry;
+import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -20,7 +21,7 @@ import org.lwjgl.opengl.GL11;
 
 import static org.lwjgl.opengl.GL11.*;
 
-public class OptionsScreen
+public class ScreenOptions
     extends Screen
 {
     private static final int TOP_SPACING = 24;
@@ -47,12 +48,12 @@ public class OptionsScreen
     private boolean doOptionsScroll = true;
     private boolean doPagesListScroll = true;
 
-    public OptionsScreen(Screen parent)
+    public ScreenOptions(Screen parent)
     {
         this(parent, OptionsPages.GENERAL);
     }
 
-    public OptionsScreen(Screen parent, OptionsPage selectedPage)
+    public ScreenOptions(Screen parent, OptionsPage selectedPage)
     {
         super(parent);
         this.selectedPage = selectedPage;
@@ -153,8 +154,12 @@ public class OptionsScreen
 
     @Override
     public void removed() {
+        for (OptionsComponent component : selectedPage.getComponents()) {
+            component.onClose();
+        }
         super.removed();
         mc.gameSettings.saveOptions();
+        mc.texturePackList.refreshIfReady();
     }
 
     private void scrollOptions(float amount) {
@@ -219,6 +224,17 @@ public class OptionsScreen
             onScrollPagesList();
         }
 
+        if (pickingKeyBinding == null && pickingKeyBindingComponent == null && mc.controllerInput != null) {
+            final int xc = (int) mc.controllerInput.cursorX;
+            if (doOptionsScroll && xc > pagesListWidth + SEPARATOR_WIDTH + PADDING && xc < width) {
+                scrollOptions(mc.controllerInput.joyRight.getY() / 0.2f);
+                onScrollOptions();
+            } else if (doPagesListScroll && xc >= 0 && xc <= pagesListWidth) {
+                scrollPagesList(mc.controllerInput.joyRight.getY() / 0.2f);
+                onScrollPagesList();
+            }
+        }
+
         pagesListWidth = (int)(width * 0.25f);
         pageWidth = width - (pagesListWidth + SEPARATOR_WIDTH + (PADDING * 2));
         I18n i18n = I18n.getInstance();
@@ -425,6 +441,9 @@ public class OptionsScreen
             }
             for(OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
                 if (mx >= 0 && mx <= pagesListWidth && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
+                    for (OptionsComponent component : selectedPage.getComponents()) {
+                        component.onClose();
+                    }
                     optionsScrollAmount = 0;
                     selectedPage = page;
                     this.selectedPage.initComponents(mc);
@@ -515,4 +534,11 @@ public class OptionsScreen
             tessellator.draw();
         }
     }
+
+    @Override
+    public void guiSpecificControllerInput(ControllerInput controller) {
+        if (controller.buttonB.pressedThisFrame()) {
+            mc.displayScreen(getParentScreen());
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
index defa9a0ff..fcdb14628 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.gui.options.OptionsScreen;
+import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.option.KeyBinding;
 
 public class KeyBindingComponent
@@ -26,8 +26,8 @@ public class KeyBindingComponent
             this.keyBinding.unbind();
             this.keyButton.displayString = this.keyBinding.getKeyName();
         } else {
-            OptionsScreen.pickingKeyBinding = keyBinding;
-            OptionsScreen.pickingKeyBindingComponent = this;
+            ScreenOptions.pickingKeyBinding = keyBinding;
+            ScreenOptions.pickingKeyBindingComponent = this;
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
index 1514368bc..1768e5c0b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
@@ -40,7 +40,9 @@ public class OptionsCategory
 
     public OptionsCategory withComponent(OptionsComponent component)
     {
-        components.add(component);
+        if (component != null) {
+            components.add(component);
+        }
         return this;
     }
 
@@ -160,6 +162,13 @@ public class OptionsCategory
         return category;
     }
 
+    @Override
+    public void onClose() {
+        for (OptionsComponent component : components) {
+            component.onClose();
+        }
+    }
+
     @Override
     public boolean matchesSearchTerm(String term)
     {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsComponent.java
index 573ca8c2a..642f206fa 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsComponent.java
@@ -20,5 +20,7 @@ public interface OptionsComponent
 
     void onKeyPress(int keyCode, char character);
 
+    default void onClose() { };
+
     boolean matchesSearchTerm(String term);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
index 9dc0737ca..d70b966cb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
@@ -115,6 +115,11 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
     @Override
     public void onKeyPress(int keyCode, char character) { }
 
+    @Override
+    public void onClose() {
+        draggedButton = null;
+    }
+
     @Override
     public boolean matchesSearchTerm(String term) {
         return false;
